package org.phosphoresce.commons.wpoi.test.model;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import org.phosphoresce.commons.wpoi.test.util.CommonUtils;

/**
 * TvNX<br>
 * f[^f<br>
 * 
 * @author Kitagawa<br>
 * 
 *<!--
 * XV       XV          XVe
 * 2005/12/07	Kitagawa		VK쐬
 *-->
 */
public final class Section extends Model {

	/**  */
	private Company company = null;

	/** R[h */
	private String code = null;

	/** 喼 */
	private String name = null;

	/** Ј */
	private Employee[] employees = null;

	/**
	 * RXgN^<br>
	 * @param code R[h
	 * @param name 喼
	 */
	public Section(String code, String name) {
		super();
		this.code = code;
		this.name = name;
	}

	/**
	 * RXgN^<br>
	 * @param code R[h
	 * @param name 喼
	 * @param employees Ј
	 */
	public Section(String code, String name, Employee[] employees) {
		super();
		this.code = code;
		this.name = name;
		this.employees = employees;
	}

	/**
	 * Јǉ܂B<br>
	 * @param employee Ј
	 */
	public void addEmployee(Employee employee) {
		List buffer = new LinkedList(Arrays.asList(getEmployees()));
		if (employee != null && !buffer.contains(employee)) {
			employee.addSection(this);

			buffer.add(employee);
		}
		employees = (Employee[]) CommonUtils.castArray(Employee.class, buffer);
	}

	/**
	 * Ј폜܂B<br>
	 * @param employee Ј
	 */
	public void removeEmployee(Employee employee) {
		List buffer = new LinkedList(Arrays.asList(getEmployees()));
		if (buffer.contains(employee)) {
			employee.removeSection(this);

			buffer.remove(employee);
		}
		employees = (Employee[]) CommonUtils.castArray(Employee.class, buffer);
	}

	/**
	 * Ј擾܂B<br>
	 * @return Ј
	 */
	public Long getEmployeeCount() {
		return new Long(getEmployees().length);
	}

	/**
	 * R[h擾܂B<br>
	 * @return R[h
	 */
	public String getCode() {
		return code;
	}

	/**
	 * R[hݒ肵܂B<br>
	 * @param code R[h
	 */
	public void setCode(String code) {
		this.code = code;
	}

	/**
	 * Ј擾܂B<br>
	 * @return Ј
	 */
	public Employee[] getEmployees() {
		return employees == null ? new Employee[] {} : employees;
	}

	/**
	 * 喼̂擾܂B<br>
	 * @return 喼
	 */
	public String getName() {
		return name;
	}

	/**
	 * 喼̂ݒ肵܂B<br>
	 * @param name 喼
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Ђ擾܂B<br>
	 * @return 
	 */
	public Company getCompany() {
		return company;
	}

	/**
	 * Ђݒ肵܂B<br>
	 * @param company 
	 */
	void setCompany(Company company) {
		this.company = company;
	}
}
